=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2013-01-14 10:50:30 +0000
+++ CMakeLists.txt	2013-01-14 15:47:33 +0000
@@ -28,3 +28,4 @@
     COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
 add_subdirectory(src)
+add_subdirectory(tests)

=== modified file 'debian/changelog'
--- debian/changelog	2013-01-14 12:14:52 +0000
+++ debian/changelog	2013-01-14 15:47:33 +0000
@@ -1,5 +1,9 @@
 kalossi-browser (0.1) UNRELEASED; urgency=low
 
+  [ Olivier Tilloy ]
   * Initial packaging.
 
+  [ Michael Zanetti ]
+  * Added initial autopilot tests and autopilot package
+
  -- Olivier Tilloy <olivier.tilloy@canonical.com>  Mon, 14 Jan 2013 13:02:15 +0100

=== modified file 'debian/control'
--- debian/control	2013-01-14 12:14:52 +0000
+++ debian/control	2013-01-14 15:47:33 +0000
@@ -6,6 +6,7 @@
                cmake (>= 2.8.9),
                qtbase (>= 5.0),
                qtdeclarative (>= 5.0),
+               mesa-common-dev,
 Standards-Version: 3.9.3
 
 Package: kalossi-browser
@@ -16,3 +17,13 @@
 Description: Kalossi web browser
  Kalossi is a lightweight web browser tailored for Ubuntu, based on the Webkit
  rendering engine and using the Ubuntu UI components.
+
+Package: kalossi-browser-autopilot
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         kalossi-browser,
+Description: Kalossi web browser autopilot tests
+ Kalossi is a lightweight web browser tailored for Ubuntu, based on the Webkit
+ rendering engine and using the Ubuntu UI components. This package contains 
+ autopilot tests for it.

=== added file 'debian/kalossi-browser-autopilot.install'
--- debian/kalossi-browser-autopilot.install	1970-01-01 00:00:00 +0000
+++ debian/kalossi-browser-autopilot.install	2013-01-14 15:47:33 +0000
@@ -0,0 +1,2 @@
+usr/lib/python*/dist-packages/kalossi_browser/*
+

=== added file 'debian/kalossi-browser.install'
--- debian/kalossi-browser.install	1970-01-01 00:00:00 +0000
+++ debian/kalossi-browser.install	2013-01-14 15:47:33 +0000
@@ -0,0 +1,1 @@
+usr/bin/kalossi-browser

=== modified file 'src/Chrome.qml'
--- src/Chrome.qml	2013-01-11 16:04:33 +0000
+++ src/Chrome.qml	2013-01-14 15:47:33 +0000
@@ -80,6 +80,7 @@
 
     TextField {
         id: addressBar
+        objectName: "addressBar"
 
         anchors.left: buttons.right
         anchors.right: loading.left

=== added directory 'tests'
=== added file 'tests/CMakeLists.txt'
--- tests/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ tests/CMakeLists.txt	2013-01-14 15:47:33 +0000
@@ -0,0 +1,1 @@
+add_subdirectory(autopilot)

=== added directory 'tests/autopilot'
=== added file 'tests/autopilot/CMakeLists.txt'
--- tests/autopilot/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ tests/autopilot/CMakeLists.txt	2013-01-14 15:47:33 +0000
@@ -0,0 +1,9 @@
+set(AUTOPILOT_DIR kalossi_browser)
+
+execute_process(COMMAND python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()"
+    OUTPUT_VARIABLE PYTHON_PACKAGE_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+install(DIRECTORY ${AUTOPILOT_DIR}
+    DESTINATION ${PYTHON_PACKAGE_DIR}
+    )
+

=== added directory 'tests/autopilot/kalossi_browser'
=== added file 'tests/autopilot/kalossi_browser/__init__.py'
--- tests/autopilot/kalossi_browser/__init__.py	1970-01-01 00:00:00 +0000
+++ tests/autopilot/kalossi_browser/__init__.py	2013-01-14 15:47:33 +0000
@@ -0,0 +1,8 @@
+# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
+# Copyright 2012 Canonical
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+
+"""Kalossi browser autopilot tests and emulators - top level package."""

=== added directory 'tests/autopilot/kalossi_browser/emulators'
=== added file 'tests/autopilot/kalossi_browser/emulators/__init__.py'
--- tests/autopilot/kalossi_browser/emulators/__init__.py	1970-01-01 00:00:00 +0000
+++ tests/autopilot/kalossi_browser/emulators/__init__.py	2013-01-14 15:47:33 +0000
@@ -0,0 +1,6 @@
+# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
+# Copyright 2012 Canonical
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.

=== added file 'tests/autopilot/kalossi_browser/emulators/main_window.py'
--- tests/autopilot/kalossi_browser/emulators/main_window.py	1970-01-01 00:00:00 +0000
+++ tests/autopilot/kalossi_browser/emulators/main_window.py	2013-01-14 15:47:33 +0000
@@ -0,0 +1,19 @@
+class MainWindow(object):
+    """An emulator class that makes it easy to interact with the camera-app."""
+
+    def __init__(self, app):
+        self.app = app
+
+    def get_qml_view(self):
+        """Get the main QML view"""
+        return self.app.select_single("QQuickView")
+
+    def get_address_bar(self):
+        """Get the browsers address bar"""
+        return self.app.select_single("TextField", objectName="addressBar")
+
+    def get_address_bar_clear_button(self):
+        return self.get_address_bar().get_children_by_type("AbstractButton")[0]
+
+    def get_web_view(self):
+        return self.app.select_single("QQuickWebView")

=== added directory 'tests/autopilot/kalossi_browser/tests'
=== added file 'tests/autopilot/kalossi_browser/tests/__init__.py'
--- tests/autopilot/kalossi_browser/tests/__init__.py	1970-01-01 00:00:00 +0000
+++ tests/autopilot/kalossi_browser/tests/__init__.py	2013-01-14 15:47:33 +0000
@@ -0,0 +1,50 @@
+# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
+# Copyright 2012 Canonical
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+
+"""Kalossi-browser autopilot tests."""
+
+from os import remove
+import os.path
+
+from autopilot.introspection.qt import QtIntrospectionTestMixin
+from autopilot.testcase import AutopilotTestCase
+
+from kalossi_browser.emulators.main_window import MainWindow
+
+class BrowserTestCase(AutopilotTestCase, QtIntrospectionTestMixin):
+
+    """A common test case class that provides several useful methods for camera-app tests."""
+
+    def setUp(self):
+        super(BrowserTestCase, self).setUp()
+        # Lets assume we are installed system wide if this file is somewhere in /usr
+        if os.path.realpath(__file__).startswith("/usr/"):
+            self.launch_test_installed()
+        else:
+            self.launch_test_local()
+
+    def launch_test_local(self):
+        self.app = self.launch_test_application(
+            "../../src/kalossi-browser")
+
+    def launch_test_installed(self):
+        if self.running_on_device():
+            self.app = self.launch_test_application(
+               "kalossi-browser",
+               "--fullscreen")
+        else:
+            self.app = self.launch_test_application(
+               "kalossi-browser")
+
+    @staticmethod
+    def running_on_device():
+        return os.path.isfile('/system/usr/idc/autopilot-finger.idc')
+
+    @property
+    def main_window(self):
+        return MainWindow(self.app)
+

=== added file 'tests/autopilot/kalossi_browser/tests/test_mainwindow.py'
--- tests/autopilot/kalossi_browser/tests/test_mainwindow.py	1970-01-01 00:00:00 +0000
+++ tests/autopilot/kalossi_browser/tests/test_mainwindow.py	2013-01-14 15:47:33 +0000
@@ -0,0 +1,49 @@
+# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
+# Copyright 2012 Canonical
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+
+"""Tests for the Browser"""
+
+from __future__ import absolute_import
+
+from testtools.matchers import Equals, NotEquals, GreaterThan
+from autopilot.matchers import Eventually
+
+from kalossi_browser.tests import BrowserTestCase
+
+import unittest
+import time
+import os
+from os import path
+
+class TestMainWindow(BrowserTestCase):
+    """Tests the main browser features"""
+
+    """ This is needed to wait for the application to start.
+        In the testfarm, the application may take some time to show up."""
+    def setUp(self):
+        super(TestMainWindow, self).setUp()
+        self.assertThat(self.main_window.get_qml_view().visible, Eventually(Equals(True)))
+
+    def tearDown(self):
+        super(TestMainWindow, self).tearDown()
+
+    """Test opening a website"""
+    def test_open_website(self):
+        address_bar = self.main_window.get_address_bar()
+        self.pointing_device.move_to_object(address_bar)
+        self.pointing_device.click()
+        address_bar_clear_button = self.main_window.get_address_bar_clear_button()
+        self.pointing_device.move_to_object(address_bar_clear_button)
+        self.pointing_device.click()
+        self.pointing_device.move_to_object(address_bar)
+        self.pointing_device.click()
+
+        self.keyboard.type("http://www.canonical.com")
+        self.keyboard.press("Enter")
+
+        web_view = self.main_window.get_web_view()
+        self.assertThat(web_view.url, Eventually(Equals("http://www.canonical.com/")))

